{------------------------------------------------------------------------------}
{         DBF.      }
{  ()   TSuperGrid, ..         }
{     ,            }
{ TStringGrid.                                                                 }
{------------------------------------------------------------------------------}

unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, Grids, SuperGrd, ExtCtrls, StdCtrls, ComCtrls, NewTable, DBF;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    SG: TSuperGrid;
    SpeedButton1: TSpeedButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    CB1: TCheckBox;
    CB2: TCheckBox;
    CB3: TCheckBox;
    SB1: TSpeedButton;
    SB2: TSpeedButton;
    SB3: TSpeedButton;
    SB4: TSpeedButton;
    SB5: TSpeedButton;
    SB7: TSpeedButton;
    SB8: TSpeedButton;
    SB9: TSpeedButton;
    SB6: TSpeedButton;
    CB4: TCheckBox;
    SB10: TSpeedButton;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Label1: TLabel;
    Label2: TLabel;
    RG: TRadioGroup;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    DT: TDateTimePicker;
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CB3Click(Sender: TObject);
    procedure SB1Click(Sender: TObject);
    procedure SGSelectCell(Sender: TObject; Col, Row: Integer;
      var CanSelect: Boolean);
    procedure SB2Click(Sender: TObject);
    procedure SB3Click(Sender: TObject);
    procedure SB4Click(Sender: TObject);
    procedure SB5Click(Sender: TObject);
    procedure SB6Click(Sender: TObject);
    procedure SGSetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure SB9Click(Sender: TObject);
    procedure SB10Click(Sender: TObject);
    procedure CB4Click(Sender: TObject);
    procedure SB8Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure SB7Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure RGClick(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
  private
    { Private declarations }
    procedure InitSG;
    procedure FillSG;
    procedure DisableButt;
  public
    { Public declarations }
  end;

  //    SG
  TCell = record
    Val   : String;   // 
    Cl, Rw: Integer;  // 
    Modif : Boolean;  //  
  end;

  ED = class(Exception);

const Cap = 'Test DBF';

var
  Form1: TForm1;
  CN: TCell;

implementation

{$R *.DFM}

{***  (   )  SG ***}
procedure TForm1.InitSG;
var N: Integer;
begin
  with SG do
  begin         
    ClearCells; 
    for N:=1 to ColCount do Cells[N,0]:='';
    ColCount:=2; RowCount:=2; FixedRows:=1;
  end;
  Caption:=Cap;
  with CN do begin Cl:=1; Rw:=1; Modif:=False; end;
  SB10.Enabled:=False;
end;

{***     ***}
procedure TForm1.DisableButt;
begin
  SB1.Enabled:=False;
  SB2.Enabled:=False;
  SB3.Enabled:=False;
  SB4.Enabled:=False;
  SB5.Enabled:=False;
  SB6.Enabled:=False;
  SB7.Enabled:=False;
  SB8.Enabled:=False;
  SB9.Enabled:=False;
  Button1.Enabled:=False;
  Button2.Enabled:=False;
  Button3.Enabled:=False;
  Button4.Enabled:=False;
  Button5.Enabled:=False;
  Button7.Enabled:=False;
  Button8.Enabled:=False;
  DT.Enabled:=False;
  RG.Enabled:=False;
end;

{***   SG   ***}
procedure TForm1.FillSG;
var
  K,M,N,Temp,Max: Integer;
  S: String;
begin
  with SG, CreateForm.DB do
  begin
    Caption:=Cap+' - '+ExtractFileName(TableName);
    ColCount:=FieldCount+1;
    for N:=1 to ColCount-1 do Cells[N,0]:=GetFieldName(N);
    SB5.Enabled:=True;
    SB6.Enabled:=True;
    if CreateForm.DB.IsEmpty then ShowMessage('   ');
    if RecordCount>0 then
    begin
      SB3.Enabled:=True;
      SB4.Enabled:=True;
      SB7.Enabled:=True;
      Button1.Enabled:=True;
      Button2.Enabled:=True;
      Button3.Enabled:=True;
      Button4.Enabled:=True;
      Button5.Enabled:=True;
      Button7.Enabled:=True;
      Button8.Enabled:=True;
      DT.Enabled:=True;
      RG.Enabled:=True;
      with RG do case CodePage of
        ANSI : ItemIndex:=0;
        OEM  : ItemIndex:=1;
        NONE : ItemIndex:=2;
      end;
    end else Exit;
    for M:=0 to ColCount-1 do
    begin
      Max:=Canvas.TextWidth(Cells[M,0])+1;
      First; N:=0;
      for K:=1 to RecordCount do
      begin
        if not Deleted or (Deleted and CB4.Checked) then
        begin
          Inc(N);
          if (N>1) and (M=0) then InsertRow(N);
          if M=0 then Cells[M,N]:=IntToStr(RecNo) else
          begin
            S:=GetFieldData(M);
            if CB2.Checked and (GetFieldType(M)=bfString) then Translate(S,S,False);
            Cells[M,N]:=S;
          end;
          Temp:=Canvas.TextWidth(Cells[M,N]);
          if Temp>Max then Max:=Temp;
        end;
        if not Eof then Next;
      end;
      ColWidths[M]:=Max+GridLineWidth+4;
    end;
    with CN do begin Cl:=1; Rw:=1; Modif:=False; Val:=Cells[1,1]; end;
    First;
  end;
  SB10.Enabled:=True;
end;

{***     SG    ***}
procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  InitSG; if CreateForm.DB.Active then CreateForm.DB.Close;
  DisableButt;
  if OpenDialog1.Execute then with CreateForm.DB do
  begin
    Exclusive:=CB1.Checked;
    TableName:=OpenDialog1.FileName;
    Open; FillSG;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  InitSG; DT.Date:=Now;
end;

{***    SG ***}
procedure TForm1.CB3Click(Sender: TObject);
begin
  if CreateForm.DB.IsEmpty then begin CB3.Checked:=False; Exit; end;
  with SG do if CB3.Checked then Options:=Options+[goEditing]
                            else Options:=Options-[goEditing];
end;

{***      SG     .dbf ***}
procedure TForm1.SGSelectCell(Sender: TObject; Col, Row: Integer; var CanSelect: Boolean);
var R: Integer;
begin
  if SG.Cells[0,Row]<>'' then R:=StrToInt(SG.Cells[0,Row]) else R:=1;
  with CN do if Modif then
  with CreateForm.DB do
  begin
    //  ( )  
    if (GetFieldType(Cl)=bfString) and (RG.ItemIndex=1) then Translate(Val, Val, True);
    //   
    SetFieldData(Cl, Val); Modif:=False; Label1.Visible:=Modified;
  end;
  if Row<>CN.Rw then  //      .dbf
  begin
    SB8.Enabled:=False; SB9.Enabled:=False;
    //  
    if R=1 then
      begin
        CreateForm.DB.First; SB1.Enabled:=False; SB2.Enabled:=False;
        if SG.RowCount>2 then begin SB3.Enabled:=True; SB4.Enabled:=True; end;
      end;
    //  
    if R=CreateForm.DB.RecordCount then
      begin
      CreateForm.DB.Last; SB3.Enabled:=False; SB4.Enabled:=False;
      if SG.RowCount>2 then begin SB1.Enabled:=True; SB2.Enabled:=True; end;
    end;
  end;
  //    ...
  if (R>1) and (R<CreateForm.DB.RecordCount) then
  begin
    if (R-CN.Rw)=1 then CreateForm.DB.Next               //   
    else if (CN.Rw-R)=1 then CreateForm.DB.Prior         //   
    else if CN.Rw<>R then CreateForm.DB.GoToRecord(R); //    ...
    SB1.Enabled:=True; SB2.Enabled:=True;
    SB3.Enabled:=True; SB4.Enabled:=True;
  end;
  if CreateForm.DB.Bof then Label2.Caption:='Begin' else
    if CreateForm.DB.Eof then Label2.Caption:='End' else Label2.Caption:='';
  //    SG      
  with SG, CN do if Canvas.TextWidth(Cells[Cl, Rw])>ColWidths[Cl] then
    ColWidths[Cl]:=Canvas.TextWidth(Cells[Cl, Rw])+GridLineWidth+4;
  with CN do begin Cl:=Col; Rw:=Row; Val:=SG.Cells[Cl,Rw]; end;
  Label1.Visible:=CreateForm.DB.Modified;
end;

procedure TForm1.SB1Click(Sender: TObject);  // First
begin
  SG.Row:=1;
end;

procedure TForm1.SB2Click(Sender: TObject);  // Prior
begin
  with SG do if Row>1 then Row:=Row-1;  
end;

procedure TForm1.SB3Click(Sender: TObject);  // Next
begin
  with SG do if Row<(RowCount-1) then Row:=Row+1;
end;

procedure TForm1.SB4Click(Sender: TObject);  // Last
begin
  with SG do Row:=RowCount-1;  
end;

{***        .dbf    SG ***}
procedure TForm1.SB5Click(Sender: TObject);
begin
  CreateForm.DB.Append; if CreateForm.DB.RecordCount>1 then SG.InsertRow(SG.RowCount);
  SG.Cells[0,SG.RowCount-1]:=IntToStr(CreateForm.DB.RecordCount);
  SG.Row:=SG.RowCount-1;
end;

{***       .dbf    SG ***}
procedure TForm1.SB6Click(Sender: TObject);
var N: Integer;
begin
  CreateForm.DB.Insert; if CreateForm.DB.RecordCount>1 then SG.InsertRow(CN.Rw); 
  for N:=CN.Rw to SG.RowCount-2 do SG.Cells[0,N]:=SG.Cells[0,N+1];
  if CreateForm.DB.RecordCount>1 then
    SG.Cells[0,SG.RowCount-1]:=IntToStr(StrToInt(SG.Cells[0,SG.RowCount-2])+1)
  else SG.Cells[0,1]:='1';
end;

{***      SG (modified) ***}
procedure TForm1.SGSetEditText(Sender: TObject; ACol, ARow: Integer; const Value: String);
begin
  with CN do if (Val<>Value) and (Cl=ACol) and (Rw=ARow) then
  begin
    Modif:=True; Val:=Value;
    SB8.Enabled:=True; SB9.Enabled:=True;
  end;
end;

{***  ,     ***}
procedure TForm1.SB9Click(Sender: TObject);
var N: Integer;
begin
  CreateForm.DB.Cancel; SB8.Enabled:=False; SB9.Enabled:=False;
  with SG do for N:=1 to ColCount-1 do Cells[N, Row]:=CreateForm.DB.GetFieldData(N);
end;

{***   SG    .dbf ***}
procedure TForm1.SB10Click(Sender: TObject);
begin
  with CreateForm.DB do if Active then begin InitSG; Refresh; FillSG; end;
end;

{***  ( )  .dbf,    ***}
procedure TForm1.CB4Click(Sender: TObject);
begin
  SB10.Click;
end;

{***       ***}
procedure TForm1.SB8Click(Sender: TObject);
begin
  with CN do if Modif then
  begin
    CreateForm.DB.SetFieldData(Cl, Val); Modif:=False; Label1.Visible:=CreateForm.DB.Modified;
  end;
  CreateForm.DB.Post; SB8.Enabled:=False; SB9.Enabled:=False;
end;

{***      ***}
procedure TForm1.Button1Click(Sender: TObject);
var N: Integer;
begin
  CreateForm.DB.ClearFields;
  for N:=1 to CreateForm.DB.FieldCount do SG.Cells[N,CN.Rw]:=CreateForm.DB.GetFieldData(N);
  SB8.Enabled:=True; SB9.Enabled:=True;
end;

{***      ***}
procedure TForm1.SB7Click(Sender: TObject);
begin
  CreateForm.DB.Deleted:=True; if not CB4.Checked then SB10.Click;
end;

{***      ***}
procedure TForm1.Button2Click(Sender: TObject);
begin
  with CreateForm.DB do if Deleted then Deleted:=False; 
end;

{***       SG ***}
procedure TForm1.Button3Click(Sender: TObject);
var T: String;
begin
  case CreateForm.DB.GetFieldType(CN.Cl) of
    bfBoolean : T:='bfBoolean';
    bfDate    : T:='bfDate';
    bfFloat   : T:='bfFloat';
    bfNumber  : T:='bfNumber';
    bfString  : T:='bfString';
    bfUnkown  : T:='bfUnkown';
  end;                              
  ShowMessage(' '+#9+': '+CreateForm.DB.GetFieldName(CN.Cl)+#13+
              ' '+#9+': '+T+#13+
              ' '+#9+': '+IntToStr(CreateForm.DB.GetFieldSize(CN.Cl))+#13+
              ''+#9+': '+IntToStr(CreateForm.DB.GetFieldPrecision(CN.Cl))+#13+
              ' '+#9+': '+CreateForm.DB.GetFieldData(CN.Cl));
end;

{***     .dbf (      ) ***}
procedure TForm1.RGClick(Sender: TObject);
begin
  with CreateForm.DB do
  case RG.ItemIndex of
    0 : CodePage:=ANSI;
    1 : CodePage:=OEM;
    2 : CodePage:=NONE;
  end;
end;

{***      .dbf   SG ***}
procedure TForm1.Button4Click(Sender: TObject);
begin
  if MessageBox(0,' ?', Cap, mb_iconwarning+mb_yesno)=idyes then
    begin CreateForm.DB.EmptyTable; InitSG; FillSG; CB3.Checked:=False; end;
end;

{***   .dbf (    ,   ) ***}
procedure TForm1.Button5Click(Sender: TObject);
begin
  CreateForm.DB.PackTable; InitSG; FillSG;
end;

{***    .dbf ***}
procedure TForm1.Button6Click(Sender: TObject);
begin
  InitSG; if CreateForm.DB.Active then CreateForm.DB.Close;
  DisableButt;
  CreateForm.ShowModal; //        
  if CreateForm.DB.Active then FillSG;
end;

{***      .dbf ***}
procedure TForm1.Button7Click(Sender: TObject);
begin
  ShowMessage('   '+#13+
              ExtractFileName(CreateForm.DB.TableName)+' : '+
              DateToStr(CreateForm.DB.DbfDate));
end;

{***       .dbf ***}
procedure TForm1.Button8Click(Sender: TObject);
begin
  with CreateForm.DB do
  begin
    DbfDate:=DT.Date;
    ShowMessage('    '+#13+
                ExtractFileName(TableName)+' : '+DateToStr(DbfDate));
  end;
end;

end.
